
_set_up:

;EXT_INT_RB0.c,4 :: 		void set_up(void) {
;EXT_INT_RB0.c,6 :: 		ANSEL = 0;      // Pin RA2 sets as analog input.
	CLRF       ANSEL+0
;EXT_INT_RB0.c,7 :: 		ANSELH = 0;      // The rest of the pins set as digital Inputs or outputs.
	CLRF       ANSELH+0
;EXT_INT_RB0.c,8 :: 		C1ON_bit = 0;    // Analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;EXT_INT_RB0.c,9 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;EXT_INT_RB0.c,10 :: 		CCP1CON = 0;   //PWM1 y PWM2 off.
	CLRF       CCP1CON+0
;EXT_INT_RB0.c,11 :: 		CCP2CON = 0;
	CLRF       CCP2CON+0
;EXT_INT_RB0.c,12 :: 		TRISD0_bit=0;
	BCF        TRISD0_bit+0, BitPos(TRISD0_bit+0)
;EXT_INT_RB0.c,13 :: 		RD0_bit =0;
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
;EXT_INT_RB0.c,14 :: 		GIE_bit=1;        // Enabled interrupts.
	BSF        GIE_bit+0, BitPos(GIE_bit+0)
;EXT_INT_RB0.c,15 :: 		NOT_RBPU_bit=0;   //Enabled Pull ups.
	BCF        NOT_RBPU_bit+0, BitPos(NOT_RBPU_bit+0)
;EXT_INT_RB0.c,16 :: 		INTEDG_bit=0;    //INT to falling edge mode.
	BCF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;EXT_INT_RB0.c,17 :: 		TRISB0_bit=1;   //RB0 as input.
	BSF        TRISB0_bit+0, BitPos(TRISB0_bit+0)
;EXT_INT_RB0.c,18 :: 		INTE_bit=1;    //Enabled external interruption.
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
;EXT_INT_RB0.c,19 :: 		Sound_Init(&PORTD, 0); // RD0 is the sound ouput.
	MOVLW      PORTD+0
	MOVWF      FARG_Sound_Init_snd_port+0
	CLRF       FARG_Sound_Init_snd_pin+0
	CALL       _Sound_Init+0
;EXT_INT_RB0.c,20 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_timbre:

;EXT_INT_RB0.c,22 :: 		void timbre() {
;EXT_INT_RB0.c,24 :: 		short int j=0 ,i=0;
	CLRF       timbre_j_L0+0
	CLRF       timbre_i_L0+0
;EXT_INT_RB0.c,26 :: 		for(i=0; i<=3; i++) {
	CLRF       timbre_i_L0+0
L_timbre0:
	MOVLW      128
	XORLW      3
	MOVWF      R0+0
	MOVLW      128
	XORWF      timbre_i_L0+0, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_timbre1
;EXT_INT_RB0.c,28 :: 		Sound_Play(1538, 100);
	MOVLW      2
	MOVWF      FARG_Sound_Play_freq_in_hz+0
	MOVLW      6
	MOVWF      FARG_Sound_Play_freq_in_hz+1
	MOVLW      100
	MOVWF      FARG_Sound_Play_duration_ms+0
	MOVLW      0
	MOVWF      FARG_Sound_Play_duration_ms+1
	CALL       _Sound_Play+0
;EXT_INT_RB0.c,26 :: 		for(i=0; i<=3; i++) {
	INCF       timbre_i_L0+0, 1
;EXT_INT_RB0.c,29 :: 		}
	GOTO       L_timbre0
L_timbre1:
;EXT_INT_RB0.c,30 :: 		for(j=0; j<=2; j++) {
	CLRF       timbre_j_L0+0
L_timbre3:
	MOVLW      128
	XORLW      2
	MOVWF      R0+0
	MOVLW      128
	XORWF      timbre_j_L0+0, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_timbre4
;EXT_INT_RB0.c,32 :: 		Sound_Play(1169, 200);
	MOVLW      145
	MOVWF      FARG_Sound_Play_freq_in_hz+0
	MOVLW      4
	MOVWF      FARG_Sound_Play_freq_in_hz+1
	MOVLW      200
	MOVWF      FARG_Sound_Play_duration_ms+0
	CLRF       FARG_Sound_Play_duration_ms+1
	CALL       _Sound_Play+0
;EXT_INT_RB0.c,30 :: 		for(j=0; j<=2; j++) {
	INCF       timbre_j_L0+0, 1
;EXT_INT_RB0.c,33 :: 		}
	GOTO       L_timbre3
L_timbre4:
;EXT_INT_RB0.c,35 :: 		delay_ms(100);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L_timbre6:
	DECFSZ     R13+0, 1
	GOTO       L_timbre6
	DECFSZ     R12+0, 1
	GOTO       L_timbre6
	DECFSZ     R11+0, 1
	GOTO       L_timbre6
	NOP
;EXT_INT_RB0.c,36 :: 		}
L_end_timbre:
	RETURN
; end of _timbre

_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;EXT_INT_RB0.c,38 :: 		void interrupt(void)
;EXT_INT_RB0.c,40 :: 		Delay_ms(20);
	MOVLW      52
	MOVWF      R12+0
	MOVLW      241
	MOVWF      R13+0
L_interrupt7:
	DECFSZ     R13+0, 1
	GOTO       L_interrupt7
	DECFSZ     R12+0, 1
	GOTO       L_interrupt7
	NOP
	NOP
;EXT_INT_RB0.c,41 :: 		if (RB0_bit==0) contador=1;  //Putton is pressed.
	BTFSC      RB0_bit+0, BitPos(RB0_bit+0)
	GOTO       L_interrupt8
	MOVLW      1
	MOVWF      _contador+0
L_interrupt8:
;EXT_INT_RB0.c,42 :: 		while (RB0_bit==0);          //Wait while it is pressed.
L_interrupt9:
	BTFSC      RB0_bit+0, BitPos(RB0_bit+0)
	GOTO       L_interrupt10
	GOTO       L_interrupt9
L_interrupt10:
;EXT_INT_RB0.c,43 :: 		if(contador ==1) timbre();   //If is free then go to timbre.
	MOVF       _contador+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_interrupt11
	CALL       _timbre+0
L_interrupt11:
;EXT_INT_RB0.c,44 :: 		contador = 0;
	CLRF       _contador+0
;EXT_INT_RB0.c,45 :: 		INTF_bit=0;
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
;EXT_INT_RB0.c,46 :: 		}
L_end_interrupt:
L__interrupt17:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_main:

;EXT_INT_RB0.c,48 :: 		void main() {
;EXT_INT_RB0.c,49 :: 		set_up();
	CALL       _set_up+0
;EXT_INT_RB0.c,50 :: 		while (1)
L_main12:
;EXT_INT_RB0.c,52 :: 		asm SLEEP
	SLEEP
;EXT_INT_RB0.c,53 :: 		asm NOP //wait the external interrupt.
	NOP
;EXT_INT_RB0.c,54 :: 		}
	GOTO       L_main12
;EXT_INT_RB0.c,55 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
